/* . . . . . . BEGIN . . . . . . . . . . . . */
extern int ceos(char a[]);

extern double degtorad(double theta);

extern double radtodeg(double theta);

extern double misc_rasep( double ra1, double ra2);

extern void xyz2radec(double x, double y, double z, double *ra, double *dec);

extern void radec2xyz(double ra, double dec, double *x, double *y, double *z);

extern void xyz2prime(double x, double y, double z, double RM[3][3],
               double *xp, double *yp, double *zp);

extern void prime2xyz(double xp, double yp, double zp, double RMinv[3][3],
               double *x, double *y, double *z);

extern void dd_radec2prime( double ra, double dec, double RMinv[3][3], double *ypd, double *zpd );

extern void dd_prime2radec( double ypd, double zpd, double RMinv[3][3], double *ra, double *dec );

extern double MatDet2D(double aa[2][2]);

extern double MatSubDet3D(int col, int row, double aa[3][3]);

extern double MatDet3D(double aa[3][3]);

extern double MatCof3D(int col, int row, double aa[3][3]);

extern void MatInv3D(double mm[3][3], double mminv[3][3] );

extern void SetRotationMatrix( double alpha, double theta, RMtype RM[1] );

extern void misc_append_to_file( char userfile[], char userline[] );

extern void misc_delete_file( char wrd[] );

extern void cpauseit();

extern void misc_system( char wrd[] );

extern void cDoBin4(int bin, int *np, float xx[], int mode);

extern int gmtimeget();

extern void timegetstring(char uline[]);

extern void timegetstring_gmt(char uline[]);

extern int cint( double rr );

extern int cnint( double rr );

extern void WriteString9(double value, char ss[]);

extern void WriteString7(double value, char ss[]);

extern int cfc(char a[]);

extern int clc(char a[]);

extern void strprefix( char a[], char b[] );

extern void strprefix_wb( char a[], char b[] );

extern void substrcpy( char a[], int a1, int a2, char b[], int b1 );

extern void substrcpy_terminate( char a[], int a1, int a2, char b[], int b1 );

extern int fgetline(char userline[], FILE *fu);

extern int numeral(char cc);

extern double cangsep(double ra1, double dec1, double ra2, double dec2);

extern FILE *fopen_read( char file[] );

extern FILE *fopen_write( char file[] );

extern int FileExist( char filename[] );

extern int numeric(char cc);

extern int numeric_string(char wrd[]);

extern int nondelim( char cc, int mode );

extern void clower_case(char a[]);

extern void cupper_case(char a[]);

extern int cindex_reverse(char a[], char b[] );

extern int cindex2(char a[], char b[], int ptr );

extern int cindex(char a[], char b[] );

extern int sck(char a[], char b[]);

extern int substrcmp0(char a[], char b[], int n );

extern double cvalread(char userline[], int up1, int up2);

extern double cvalread0( char userline[], int up1, int up2 );

extern void FindWord( char line[], int pp, int *sow, int *eow, int *ok, int mode );

extern void FindNumericWord(char line[], int pp, int *sow, int *eow, int *ok);

extern double GetLineValue(char line[], int nn);

extern double GetLineValueError(char line[], int nn);

extern double GetLineValueQuiet(char line[], int nn);

extern double GLVQ(char line[], int nn);

extern double GLVE(char line[], int nn);

extern double GLV(char line[], int nn);

extern int cfindarg(char arg[202][200], int *narg, char parm[], char d, char wrd[] );

extern void cargcopy(char *argv[], int argc, int *narg, char arg[202][200]);

extern void misc_word_parse( char uline[], char line[], int maxwrds, char *wrds[maxwrds], int *nwrds );

extern void misc_ranges( int nn, double aa[], double *lo, double *hi );

extern int misc_get_number_of_IPAC_columns( char ipachead[] );

extern void misc_get_IPAC_columns( char ipachead[], ITCtype ITC[] );

extern int misc_find_IPAC_column( char username[], ITCtype ITC[], int mode );

extern void misc_load_IPAC_columns( char ipachead1[], char ipachead2[], ITCtype ITC[] );

extern void misc_timepidstring( char timepid[] );

extern void misc_timepidstring2( char timepid[] );

extern double misc_get_double_IPAC( char line[], char colname[], ITCtype ITC[], int mode );

extern void misc_pad_blanks( char wrd0[], int eow, char wrd[] );

extern void misc_trim_blanks(char wrd[]);

extern void misc_get_character_IPAC( char line[], char colname[], ITCtype ITC[], int mode, char wrd[] );

extern void misc_load_integer_series( char wrd[], int *nkey, int key[], int maxkey );

extern void misc_load_integer_sequence( char wrd[], int *nkey, int key[], int maxkey );

extern double misc_datestring_to_unixtime_2( char ds[] );

extern double misc_datestring_to_unixtime( char ds[] );

extern double misc_convert_time_string( char ts[] );

extern int misc_file_unixtime_UTC( char file[] );

extern int misc_file_size( char file[] );

extern void misc_ls_date( char line[], char ts[] );

extern double misc_julian_to_unixtime( double jd );

extern double misc_unixtime_to_julian( double unixtime );

extern void misc_reverse_unix_time( double unixtime, char ts[] );

extern void cqcksrt4(int nn, float arr[] );

extern void cqcksrt8(int nn, double arr[] );

extern void cqcksrtkey4(float arr[], int nkey, int key[] );

extern void cqcksrtkey8(double arr[], int nkey, int key[] );

extern float cfind_median_key(float arr[], int nkey, int key[] );

extern float cfind_median(int nn, float arr[] );

extern float cfind_median_average( int nn, float arr[], int nrej );

extern double cfind_median8(int nn, double arr[] );

extern double cfind_median_average8( int nn, double arr8[], int nrej );

extern float cfind_median_rejections( int npt, float dat[], float wt[],
                               float arr[], float rejsig, int maxrej );

extern float cfind_mean_rms( int narr, float arr[], float *rms );

extern float cfind_median_deviant_average( int nn, float arr[], int nrej, int mask[],
                                    float *rms );

extern void cASCII_to_PS(char afile[], char psfile[],
        int ptsz, int left, int bold, int land, int head, char font[] );

extern int misc_read_CSV( char file[], int xxtc, int yytc, float xx[], float yy[] );

extern void misc_read_IPAC_column_names( char infile[], char *names[], char *forms[], int *nc );

extern void misc_read_IPAC_float( char file[], char *names[], int nc, int maxpt, int *nr, float img[], int verbose );

extern void misc_read_IPAC_double( char file[], char *names[], int nc, int maxpt, int *nr, double img[], int verbose );

extern void misc_load_IDD_int( IDDtype IDD, char column[], int iaa[] );

extern void misc_load_IDD( IDDtype IDD, char column[], double aa[] );

extern void misc_read_IDD( char ipacfile[], char columns[], IDDtype *IDD, int verbose );

extern void misc_free_IDD( IDDtype IDD );

extern void misc_load_IFD( IFDtype IFD, char column[], float aa[] );

extern void misc_read_IFD( char ipacfile[], char columns[], IFDtype *IFD, int verbose );

extern void misc_free_IFD( IFDtype IFD );

extern int misc_gregorian_to_julian( int year, int month, int day );

extern void misc_julian_to_gregorian( int jd, int *year, int *month, int *day );

extern double misc_zulu_to_julian( char zdate[] );

extern void misc_julian_to_zulu( double djd, char zdate[] );

extern double misc_julian_to_uth( double djd );

extern double misc_zulu_to_decimal_year( char zdate[] );

extern double current_julian();

extern double misc_doy_to_julian( int year, double doy );

extern void misc_doy_to_calendar( int year, int doy, char ds[] );

extern double misc_hms2deci( int hh, int mm, double ss, int mode );

extern double misc_hmss2deci( char hms[], int mode );

extern void misc_deci2hms( double dcm, int *hh, int *mm, double *ss, double *thesign );

extern void misc_write_radec(double ra, double dec, int mode, char ss[]);

extern double misc_ast_julday(double epoch);

extern void misc_ast_rotmatrix(double epoch, double p[3][3]);

extern void misc_ast_precess(double  ra1, double  dec1, double epoch1,
                  double *ora2, double *odec2, double epoch2);

extern double local_sidereal( double jd, double longitude );

extern void misc_twilight_times( double twilight, double ujd, double longitude, double latitude,
                          double *jd12a, double *jd12b, double *lst12a, double *lst12b );

extern double cpolyval(int nc, double co[], double xv);

extern void GJ_gaussj( const int np, double a[np][np], int n, double b[] );

extern void GJ_covsrt( const int ncvm, int ma, int mfit,
                double covar[ncvm][ncvm], int lista[] );

extern void GJ_polyfuncs( int np, double x, double p[] );

extern void GJ_lfit( int ndata, int ma, const int ncvm,
              double x[], double y[], double sig[],
              double a[], int lista[], int mfit,
              double covar[ncvm][ncvm], double *chisq );

extern void GJ_polyfit_residuals( int npt, double x[], double y[], double wt[],
                           int order, double xoff, double coef[],
                           double *high, double *wrms, double *wppd );

extern int GJ_polyfit( int npt, double x[], double y[], double wt[], int order,
                int forcexoff, double *xoff, double ucoef[] );

extern void misc_Smooth_Image( int nc, int nr, float img[], float ref[], int colrad, int rowrad );

/* . . . . . . END . . . . . . . . . . . . . */
